/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */

#ifndef BITTORRENT_CLIENT_H
#define BITTORRENT_CLIENT_H

#include "ns3/application.h"
#include "ns3/socket.h"

#include "ns3/MetainfoFile.h"
#include "ns3/ClientDatabase.h"
#include "ns3/TrackerManager.h"
#include "ns3/ConnectionManager.h"

namespace ns3 {

class BitTorrentClient : public Application
{
public:
  BitTorrentClient(Ptr<MetainfoFile> metainfo, bool seeder = false);
  virtual ~BitTorrentClient();

  void setAsn(uint16_t asn);

private:
  BitTorrentClient();

public:
  Ptr<Socket> CreateTcpSocket(void);
  Ipv4Address ClientIpv4Address(void);

protected:
  virtual void DoDispose(void);

private:
  virtual void StartApplication(void);
  virtual void StopApplication(void);

  void CLIENT_LOG_INFO(std::string info);


private:
  Ptr<MetainfoFile>      m_metainfoFile;
  Ptr<ClientDatabase>    m_clientDB;

  Ptr<TrackerManager>    m_trackerManager;
  Ptr<ConnectionManager> m_connectionManager;

};

}

#endif /* BITTORRENT_CLIENT_H */

