/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef LISTENING_PEER_CONNECTION_H
#define LISTENING_PEER_CONNECTION_H

#include "ns3/object.h"
#include <map>

namespace ns3 {

class ConnectionManager;
class Socket;
class Packet;

class ListeningPeerConnection : public Object
{

public:
  ListeningPeerConnection(Ptr<ConnectionManager> connectionManager);
private:
  ListeningPeerConnection();

public:
  bool StartListening(uint16_t port);
  bool StopListening(void);

  void HandleAccept(Ptr<Socket> socket, const Address& from);
  void HandleRead(Ptr<Socket> socket);
  void HandlePeerClose(Ptr<Socket> socket);
  void HandlePeerError(Ptr<Socket> socket);

  void EntrustPeerConnection(Ptr<Socket> socket, std::string peerId);

private:
  void LISTENING_LOG_INFO(std::string info);

private:
  Ptr<ConnectionManager> m_connectionManager;

  Ptr<Socket> m_socket;

  uint32_t m_nConnection;
  std::map<Ptr<Socket>, Ptr<Packet> > m_acceptedSocketList;
};

}

#endif /* LISTENING_PEER_CONNECTION_H */

