/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */

#include <math.h>

#include "MetainfoFile.h"

namespace ns3 {

MetainfoFile::MetainfoFile(Address trackerAddress, uint32_t fileLength, uint32_t pieceLength)
{
  m_trackerAddress = trackerAddress;
  m_infoHash       = "0a84fc42ba1e78cd91a1";

  m_fileLength     = fileLength;
  m_pieceLength    = pieceLength;
}

MetainfoFile::~MetainfoFile()
{
}

Address
MetainfoFile::trackerAddress(void)
{
  return m_trackerAddress;
}

std::string
MetainfoFile::infoHash(void)
{
  return m_infoHash;
}

uint32_t
MetainfoFile::fileLength(void)
{
  return m_fileLength;
}

uint32_t
MetainfoFile::pieceLength(void)
{
  return m_pieceLength;
}

uint32_t
MetainfoFile::pieceIndexLength(void)
{
  return ceil((double)m_fileLength/(double)m_pieceLength);
}

}

