/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef METAINFO_FILE_H
#define METAINFO_FILE_H

#include "ns3/object.h"
#include "ns3/address.h"

namespace ns3 {

class MetainfoFile : public Object
{
public:
  MetainfoFile(Address trackerAddress, uint32_t fileLength, uint32_t pieceLength);
  ~MetainfoFile();
private:
  MetainfoFile();

public:
  Address     trackerAddress(void);
  std::string infoHash(void);
  uint32_t    fileLength(void);
  uint32_t    pieceLength(void);
  uint32_t    pieceIndexLength(void);

private:
  Address     m_trackerAddress;
  std::string m_infoHash;
  uint32_t    m_fileLength;
  uint32_t    m_pieceLength;
};

}

#endif /* METAINFO_FILE_H */

