/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */

#include "PeerInformation.h"

namespace ns3 {

PeerInformation::PeerInformation(std::string peerId) : m_peerId(peerId)
{
}

PeerInformation::PeerInformation(std::string peerId, std::string ip, uint16_t port) : m_peerId(peerId)
{
  m_ip     = ip;
  m_port   = port;

}

std::string
PeerInformation::getPeerId(void) const
{
  return m_peerId;
}

std::string
PeerInformation::getIp(void) const
{
  return m_ip;
}

uint16_t
PeerInformation::getPort(void) const
{
  return m_port;
}

uint16_t
PeerInformation::getAsn(void) const
{
  return m_asn;
}

void
PeerInformation::setAsn(uint16_t asn)
{
  m_asn = asn;
}

bool
PeerInformation::isUnchoking(void) const
{
  return m_isUnchoking;
}

bool
PeerInformation::isInteresting(void) const
{
  return m_isInteresting;
}

const std::vector<bool>&
PeerInformation::getBitfield(void) const
{
  return m_bitfield;
}

//====================================================================================================

void
PeerInformation::setUnchoking(bool unchoking)
{
  m_isUnchoking = unchoking;
}

void
PeerInformation::setInteresting(bool interesting)
{
  m_isInteresting = interesting;
}

void
PeerInformation::setBitfield(std::string bitfield)
{
  m_bitfield.clear();

  for (std::string::iterator it = bitfield.begin();
       it != bitfield.end(); ++it)
    {
      for (int i=0; i<8; i++)
        m_bitfield.push_back(*it & (0x01 << (7 - i)));
    }
}

void
PeerInformation::setBitfield(uint32_t pieceIndex, bool flag)
{
  m_bitfield.at(pieceIndex) = flag;
}

}

