/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef PEER_INFORMATION_H
#define PEER_INFORMATION_H

#include "ns3/object.h"

namespace ns3 {

//TODO: implement Observer design pattern
class PeerInformation : public Object
{
public:
  PeerInformation(std::string peerId);
  PeerInformation(std::string peerId, std::string ip, uint16_t port);
private:
  PeerInformation();

public:
  std::string getPeerId(void) const;
  std::string getIp(void) const;
  uint16_t    getPort(void) const;
  uint16_t    getAsn(void) const;

  void setAsn(uint16_t asn);

  bool isUnchoking(void) const;
  bool isInteresting(void) const;

  const std::vector<bool>& getBitfield(void) const;

public:
  void setUnchoking(bool unchoking);
  void setInteresting(bool interesting);
  void setBitfield(std::string bitfield);
  void setBitfield(uint32_t pieceIndex, bool flag);

private:
  std::string m_peerId;
  std::string m_ip;
  uint16_t    m_port;
  uint16_t    m_asn;

private:
  bool m_isUnchoking;
  bool m_isInteresting;
  std::vector<bool> m_bitfield;

};

}

#endif /* PEER_INFORMATION_H */

