/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef TRACKER_MANAGER_H
#define TRACKER_MANAGER_H

#include "ns3/object.h"

namespace ns3 {

class Address;
class Socket;
class Packet;

class BitTorrentClient;
class ClientDatabase;

class TrackerManager : public Object
{
public:
  TrackerManager(Address trackerAddress, Ptr<BitTorrentClient> client, Ptr<ClientDatabase> clientDB);
private:
  TrackerManager();

public:
  bool StartRequest();
  bool StopRequest();

private:
  void CreateConnection();

  void ConnectionSucceeded(Ptr<Socket> socket);
  void ConnectionFailed(Ptr<Socket> socket);

  int SendMessage(void);
  void HandleReadResponse(Ptr<Socket> socket);

private:
  Ptr<BitTorrentClient> m_client;
  Ptr<ClientDatabase>   m_clientDB;
  Address               m_trackerAddress;

  Ptr<Socket> m_socket;
  Ptr<Packet> m_packet;

  bool        m_continue;
  EventId     m_nextAccess;
};

}

#endif /* TRACKER_MANAGER_H */

