/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef FULL_RANDOM_CONNECTION_STRATEGY_H
#define FULL_RANDOM_CONNECTION_STRATEGY_H

#include "ns3/simulator.h"

#include "ns3/ConnectionStrategyBase.h"

namespace ns3 {

class FullRandomConnectionStrategy : public ConnectionStrategyBase
{
public:
  FullRandomConnectionStrategy(Ptr<ConnectionManager> connectionManager);
private:
  FullRandomConnectionStrategy();

public:
  bool StartConnect();
  bool StopConnect();

  void ConnectStrategy();

private:
  bool FullRandomConnect();

private:
  Time    m_interval;
  EventId m_nextConnectStrategy;
};

}

#endif /* FULL_RANDOM_CONNECTION_STRATEGY_H */

