/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef FULL_RANDOM_REQUEST_STRATEGY_H
#define FULL_RANDOM_REQUEST_STRATEGY_H

#include "ns3/simulator.h"

#include "ns3/RequestStrategyBase.h"

namespace ns3 {

class FullRandomRequestStrategy : public RequestStrategyBase
{
public:
  FullRandomRequestStrategy(Ptr<PeerConnection> peerConnection);
  ~FullRandomRequestStrategy();
private:
  FullRandomRequestStrategy();

public:
  bool StartRequest(void);
  bool StopRequest(void);

  void RequestStrategy(void);

private:
  bool FullRandomRequest(void);

private:
  Time    m_interval;
  EventId m_nextRequestStrategy;

};

}

#endif /* FULL_RANDOM_REQUEST_STRATEGY_H */

