/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef REQUEST_STRATEGY_BASE_H
#define REQUEST_STRATEGY_BASE_H

#include "ns3/object.h"
#include "ns3/PeerConnection.h"

namespace ns3 {

class RequestStrategyBase : public Object
{
public:
  virtual bool StartRequest(void) = 0;
  virtual bool StopRequest(void) = 0;

protected:
  bool Request(uint32_t pieceIndex, uint32_t begin, uint32_t requestLength);

protected:
  Ptr<PeerConnection> m_peerConnection;

};

}

#endif /* REQUEST_STRATEGY_BASE_H */

