/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef SIMPLE_CHOKE_STRATEGY_H
#define SIMPLE_CHOKE_STRATEGY_H

#include "ns3/simulator.h"
#include "ns3/ChokeStrategyBase.h"

namespace ns3 {

class SimpleChokeStrategy : public ChokeStrategyBase
{
public:
  SimpleChokeStrategy(Ptr<ConnectionManager> connectionManager);
private:
  SimpleChokeStrategy();

public:
  bool StartChoke(void);
  bool StopChoke(void);

  void ChokeStrategy(void);

private:
  bool FullRandomChoke(void);

private:
  Time    m_interval;
  EventId m_nextChokeStrategy;

};

}

#endif /* SIMPLE_CHOKE_STRATEGY_H */

