/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef UNCHOKE_STRATEGY_BASE_H
#define UNCHOKE_STRATEGY_BASE_H

#include "ns3/object.h"

#include "ns3/ConnectionManager.h"

namespace ns3 {

class UnchokeStrategyBase : public Object
{
public:
  virtual bool StartUnchoke() = 0;
  virtual bool StopUnchoke() = 0;

protected:
  bool isUnchokable(Ptr<PeerConnection> peer);
  bool Unchoke(Ptr<PeerConnection> peer);

protected:
  Ptr<ConnectionManager> m_connectionManager;
};

}

#endif /* UNCHOKE_STRATEGY_BASE_H */

