/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
#ifndef WEIGHTED_RANDOM_UNCHOKE_STRATEGY_H
#define WEIGHTED_RANDOM_UNCHOKE_STRATEGY_H

#include "ns3/simulator.h"
#include "ns3/UnchokeStrategyBase.h"

namespace ns3 {

class WeightedRandomUnchokeStrategy : public UnchokeStrategyBase
{
public:
  WeightedRandomUnchokeStrategy(Ptr<ConnectionManager> connectionManager);
private:
  WeightedRandomUnchokeStrategy();

public:
  bool StartUnchoke();
  bool StopUnchoke();

  void UnchokeStrategy();

private:
  bool WeightedRandomUnchoke();

private:
  Time    m_interval;
  EventId m_nextUnchokeStrategy;

  uint32_t m_weight;

};

}

#endif /* WEIGHTED_RANDOM_UNCHOKE_STRATEGY_H */

