/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */

#include <iomanip>
#include "ns3/BitTorrentTools.h"

namespace ns3 {

std::string
BitTorrentTools::UrlEncoder(std::string rawString)
{
  std::stringstream encoded;

  for (std::string::iterator it = rawString.begin(); it!=rawString.end(); it++)
    {
      int charCode = *it;

      if (('0' <= charCode && charCode <= '9') ||
          ('a' <= charCode && charCode <= 'z') ||
          ('A' <= charCode && charCode <= 'Z') ||
          charCode == '.' || charCode == '_' ||
          charCode == '-' || charCode == '~')
        {
          encoded << *it;
        }
      else
        {
          encoded << '%' << std::setfill('0') << std::setw(2) << std::hex << std::uppercase << charCode;
        }
    }

  return encoded.str();
}

std::string
BitTorrentTools::UrlDecoder(std::string encodedString)
{
  std::stringstream decoded;

  for (std::string::iterator it = encodedString.begin(); it != encodedString.end(); it++)
    {
      if (('0' <= *it && *it <= '9') ||
          ('a' <= *it && *it <= 'z') ||
          ('A' <= *it && *it <= 'Z') ||
          *it == '.' || *it == '_' || *it == '-' || *it == '~')
        {
          decoded << *it;
        }
      else if(*it == '%')
        {
          char temp[3] = {'\0'};
          temp[0] = *(++it);
          temp[1] = *(++it);
          uint8_t t = (uint8_t)strtol(temp, NULL, 16);
          if (t != '\0')
            decoded << t;
        }
    }
  return decoded.str();
}

}
